using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// The LifeCycleResultListForm displays the results of a Life Cycle Query.
	/// This form demonstrates the use of the IRMLifeCycleResultList class.
	/// </summary>
	public class LifeCycleResultListForm : System.Windows.Forms.Form
	{
		public LifeCycleResultListForm(string taskId, ClientSession session, Control parent, IRMLifeCycleResultList resultList, int nFlPlnViewID, bool bDisplayRootsOnly)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_strTaskId = taskId;
			util = new Util(this,parent);
			m_parent = parent;
			m_session = session;
			m_IRMLifeCycleResultList = resultList;
			m_nFlPlnViewID = nFlPlnViewID;
			m_bDisplayRootsOnly = bDisplayRootsOnly;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LifeCycleResultListForm));
			this.listView1 = new System.Windows.Forms.ListView();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mnuViewLCResultListItem = new System.Windows.Forms.MenuItem();
			this.mnuEditCResultListItem = new System.Windows.Forms.MenuItem();
			this.mnuShowConflictsCResultListItem = new System.Windows.Forms.MenuItem();
			this.mnuRemoveLCResultListItem = new System.Windows.Forms.MenuItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuFindinFilePlanLCResultListItem = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.ContextMenu = this.contextMenu1;
			this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView1.FullRowSelect = true;
			this.listView1.Location = new System.Drawing.Point(0, 0);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(648, 381);
			this.listView1.SmallImageList = this.imageList1;
			this.listView1.TabIndex = 0;
			this.listView1.View = System.Windows.Forms.View.Details;
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.mnuViewLCResultListItem,
																						 this.mnuEditCResultListItem,
																						 this.mnuShowConflictsCResultListItem,
																						 this.mnuRemoveLCResultListItem,
																						 this.menuItem1,
																						 this.mnuFindinFilePlanLCResultListItem});
			// 
			// mnuViewLCResultListItem
			// 
			this.mnuViewLCResultListItem.Index = 0;
			this.mnuViewLCResultListItem.Text = "View";
			this.mnuViewLCResultListItem.Popup += new System.EventHandler(this.mnuViewLCResultListItem_Popup);
			this.mnuViewLCResultListItem.Click += new System.EventHandler(this.mnuViewLCResultListItem_Click);
			// 
			// mnuEditCResultListItem
			// 
			this.mnuEditCResultListItem.Index = 1;
			this.mnuEditCResultListItem.Text = "Edit";
			this.mnuEditCResultListItem.Click += new System.EventHandler(this.mnuEditCResultListItem_Click);
			// 
			// mnuShowConflictsCResultListItem
			// 
			this.mnuShowConflictsCResultListItem.Index = 2;
			this.mnuShowConflictsCResultListItem.Text = "Show Conflicts...";
			this.mnuShowConflictsCResultListItem.Click += new System.EventHandler(this.mnuShowConflictsCResultListItem_Click);
			// 
			// mnuRemoveLCResultListItem
			// 
			this.mnuRemoveLCResultListItem.Index = 3;
			this.mnuRemoveLCResultListItem.Text = "Remove Items";
			this.mnuRemoveLCResultListItem.Click += new System.EventHandler(this.mnuRemoveLCResultListItem_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 4;
			this.menuItem1.Text = "-";
			// 
			// mnuFindinFilePlanLCResultListItem
			// 
			this.mnuFindinFilePlanLCResultListItem.Index = 5;
			this.mnuFindinFilePlanLCResultListItem.Text = "Find in File Plan";
			this.mnuFindinFilePlanLCResultListItem.Click += new System.EventHandler(this.mnuFindinFilePlanLCResultListItem_Click);
			// 
			// LifeCycleResultListForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 381);
			this.ContextMenu = this.contextMenu1;
			this.Controls.Add(this.listView1);
			this.Name = "LifeCycleResultListForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "LifeCycleResultListForm";
			this.Load += new System.EventHandler(this.LifeCycleResultListForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#region events
		private void LifeCycleResultListForm_Load(object sender, System.EventArgs e)
		{
			CommonTasks.DisplayLifeCycleResultList(listView1,m_IRMLifeCycleResultList,m_nFlPlnViewID,m_bDisplayRootsOnly);		
		}

		private void mnuShowConflictsCResultListItem_Click(object sender, System.EventArgs e)
		{
			int count = listView1.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = listView1.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag;
				string xmlList = m_session.getBatchController().getConflictingDescendants(m_strTaskId,irm.FlPlnCmpntID,0,0);
				
				util.log(xmlList);

				ListForm frm = new ListForm(xmlList);

				frm.addColumnInfo("NameFullPath","Full Path");
				frm.addColumnInfo("NextEligiblePhaseName","NextEligiblePhaseName");
				frm.addColumnInfo("EffectiveLifeCycleCode","Effective Life Cycle Code");

				frm.ShowDialog(this);
			}
		}

		private void mnuViewLCResultListItem_Popup(object sender, System.EventArgs e)
		{
			mnuViewLCResultListItem.Enabled = true;
			mnuEditCResultListItem.Enabled = true;
			mnuShowConflictsCResultListItem.Enabled = false;
			mnuRemoveLCResultListItem.Enabled = true;

			int count = listView1.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = listView1.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				if(lvi.ImageIndex == 0)
				{
					//mnuShowConflictsCResultListItem.Enabled = true;
				}
			}
		
		}

		private void mnuRemoveLCResultListItem_Click(object sender, System.EventArgs e)
		{
			int count = listView1.SelectedItems.Count;
			if(count > 0)
			{
				string msg = "Remove Selected Components?";
				IEnumerator items = listView1.SelectedItems.GetEnumerator();
				if(count > 1)
				{
					if(MessageBox.Show(this,msg,"Life Cycle Operations",MessageBoxButtons.YesNo) == DialogResult.No)
					{
						return;
					}
				}
				string xmlList = "<List>";
				IRMComponent irm;
				while(items.MoveNext())
				{
					ListViewItem lvi = (ListViewItem)items.Current;
					irm = (IRMComponent)lvi.Tag;
					if(count == 1)
					{
						msg = "Remove Component: " + lvi.Text;
						if(MessageBox.Show(this,msg,"Life Cycle Operations",MessageBoxButtons.YesNo) == DialogResult.No)
						{
							return;
						}
					}
					xmlList += "<Item PrimaryKey=\"" + irm.FlPlnCmpntID + "\" ObjectType=\"" + irm.FlPlnCmpntDefTyp + "\" />"; 
				}
				xmlList += "</List>";
				//util.log(xmlList);
				try
				{
					m_session.getBatchController().removeComponentsFromTaskResult(m_strTaskId,xmlList);
				}
				catch(System.Net.WebException we)
				{
					util.logWebException(we);
					return;
				}
				catch(System.Web.Services.Protocols.SoapException s)
				{
					util.handleSoapException(s,false); //false indicates we will not check for time ou here
					util.showSoapException(s);
					return;
				}
				items.Reset();
				//Now Remove items from the List View
				while(items.MoveNext())
				{
					ListViewItem lvi = (ListViewItem)items.Current;
					lvi.Remove();
				}
			}			

		}

		private void mnuViewLCResultListItem_Click(object sender, System.EventArgs e)
		{
			int count = listView1.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = listView1.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag;
				CommonTasks.viewSeletedItem(m_parent,m_session,irm);
			}
		}

		private void mnuEditCResultListItem_Click(object sender, System.EventArgs e)
		{
			int count = listView1.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = listView1.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag;
				if(irm.FlPlnCmpntDefID > 0 || irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
				{
					string xml = m_session.getTemplateController().getFilePlanComponent(irm.FlPlnCmpntID,0,(int)IRMConstants.TemplateOptions.EXPAND_LISTS_AND_PROFILE_FIELDS);

					IRMFields fields = new IRMFields(xml);
					fields.hideSecurityFields(); //This is a convenience method to hide security fields if they are not being used
					fields.inactivateSecurityFields(); //This is a convenience method to make sure security fields are not added
						
					//Hide some fields we never want to display
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
						
					//Inactivate fields we do not want to be set in the Fields Collection
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
						
					ComponentForm cmpntFrm = new ComponentForm(m_session, irm ,m_parent,fields,ComponentForm.EDIT);
					if(cmpntFrm.ShowDialog(this) == DialogResult.OK)
					{
						//TODO could go through the long and complicated proccess
						//of updating changed columns
					}
				}
			}
		}

		private void mnuFindinFilePlanLCResultListItem_Click(object sender, System.EventArgs e)
		{
			int count = listView1.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = listView1.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag;

				Form1 frm = (Form1)m_parent;
				frm.SetFilePlanTabActive();
				frm.Select();
				frm.FindTreeNode(irm.FlPlnCmpntID,irm.FlPlnViewID,irm.FlPlnCmpntDefID);
			}
		}
		#endregion

		#region MemberVariables
		private Util util;
		private Control m_parent;
		
		private ClientSession m_session;
		private IRMLifeCycleResultList m_IRMLifeCycleResultList;
		private int m_nFlPlnViewID;
		private bool m_bDisplayRootsOnly;
		private string m_strTaskId;

		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mnuViewLCResultListItem;
		private System.Windows.Forms.MenuItem mnuEditCResultListItem;
		private System.Windows.Forms.MenuItem mnuShowConflictsCResultListItem;
		private System.Windows.Forms.MenuItem mnuRemoveLCResultListItem;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuFindinFilePlanLCResultListItem;
		private System.ComponentModel.IContainer components;
		#endregion

	}
}
