<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:fo="http://www.w3.org/1999/XSL/Format">
																   <!-- GROUPBY_FIELD-->
	<xsl:key name="groupBy" match="/ResultList/Data/List/Item" use="@TS_AudEntLst.ObjDefNm" />
	
	<xsl:template match="/">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

			<!-- defines page layout -->
			<fo:layout-master-set>
				<fo:simple-page-master master-name="simple" page-width="28cm" page-height="22cm" margin-top="0.5cm" margin-bottom="0.5cm" margin-left="0.5cm" margin-right="0.5cm">
					<fo:region-before extent="0.5cm"/>
					<fo:region-body margin-top="0.5cm" margin-bottom="0.5cm"/>
				</fo:simple-page-master>
			</fo:layout-master-set>


			<!-- defines the content -->
			<fo:page-sequence master-reference="simple">
				<fo:static-content flow-name="xsl-region-before" font-size="8pt">
					<fo:block  text-align="right">
					<fo:page-number/>
					<fo:inline>/</fo:inline>
					<fo:page-number-citation ref-id="terminator"/>
					</fo:block>
				</fo:static-content>
				<fo:flow flow-name="xsl-region-body">
					<fo:block font-size="14pt" font-family="Courier" font-weight="bold" text-align="center">
					Audit Entry Report
					</fo:block>
				
					<fo:table font-size="8pt">
						<xsl:variable name="width" select="27 div count(//MetaData/List/Item)"/>
						
						<!-- Column width setting  -->
						<xsl:for-each select="//MetaData/List/Item">
						<fo:table-column >
							<xsl:attribute name="column-width">
								<xsl:value-of select="$width"/>
								<xsl:text>cm</xsl:text> 
							</xsl:attribute>
						</fo:table-column>
						</xsl:for-each>
						<!-- Header -->
						<fo:table-header font-weight="bold" color="white" background-color="gray">
							<fo:table-row>
								<xsl:apply-templates select="//MetaData"/>
							</fo:table-row>													
						</fo:table-header>

						<!-- Records -->
						<fo:table-body>
							<xsl:for-each select="//Data/List/Item">
							<xsl:variable name="pos" select="position()" />										
							
									<xsl:element name="fo:table-row">
										
										<xsl:if test="($pos mod 2) = 1">
											<xsl:attribute name="background-color">white</xsl:attribute>
										</xsl:if>
										<xsl:if test="($pos mod 2) = 0">
											<xsl:attribute name="background-color">silver</xsl:attribute>
										</xsl:if>

										<xsl:for-each select="//MetaData/List/Item">

										<xsl:variable name="colName" select="@FlPlnCmpntAttrDefColNm" />


											<fo:table-cell padding="2pt">
												<fo:block text-align="start">
													<xsl:value-of select="//Data/List/Item[position()=$pos]/@*[name()=$colName]" />
												</fo:block>
											</fo:table-cell>
											
										</xsl:for-each>
										
									</xsl:element>	
									

							</xsl:for-each>
							<!-- Total -->
							<fo:table-row padding="3pt">
								
								<xsl:element name="fo:table-cell">
									<xsl:attribute name="number-columns-spanned">
										<xsl:value-of select="count(/ResultList/MetaData/List/Item)"/>
									</xsl:attribute>
									<xsl:attribute name="border-top" >solid black</xsl:attribute>
									<xsl:attribute name="border-bottom" >solid black</xsl:attribute>
									
									<fo:block text-align="start" >Total:<xsl:value-of select="count(/ResultList/Data/List/Item)" /></fo:block>
									
								</xsl:element>
								
							</fo:table-row>
						</fo:table-body>
					</fo:table>

					<fo:block font-size="14pt" font-family="Courier" font-weight="bold" text-align="center" break-before="page">
					Summary
					</fo:block>

					<fo:table font-size="8pt"  border-bottom="solid black">
						<!-- Column width setting  -->
						<fo:table-column column-width="13cm" />
						<fo:table-column column-width="13cm" />
						<!-- Summary Header -->
						<fo:table-header font-weight="bold" color="white" background-color="gray">
							<!-- Report Headers   -->
							<fo:table-row  padding="3pt">

								<fo:table-cell border-top="solid black" border-bottom="solid black">
									<fo:block>																	<!-- GROUPBY_FIELD-->
									<xsl:value-of select="/ResultList/MetaData/List/Item[@FlPlnCmpntAttrDefColNm='TS_AudEntLst.ObjDefNm']/@FlPlnCmpntAttrDefCapt"/>
									</fo:block>
								</fo:table-cell>


								<fo:table-cell border-top="solid black" border-bottom="solid black">
									<fo:block >
									Count
									</fo:block>
								</fo:table-cell>
								
							</fo:table-row>													
						</fo:table-header>
						

						<fo:table-body>
																							<!-- GROUPBY_FIELD-->
							<xsl:for-each select="//Data/List/Item[count(. | key('groupBy', @TS_AudEntLst.ObjDefNm)[1]) = 1]">
									<xsl:variable name="pos" select="position()"/>	 
						 
									<xsl:element name="fo:table-row">
										
										<xsl:if test="($pos mod 2) = 1">
											<xsl:attribute name="background-color">white</xsl:attribute>
										</xsl:if>
										<xsl:if test="($pos mod 2) = 0">
											<xsl:attribute name="background-color">silver</xsl:attribute>
										</xsl:if>
									
																			 <!-- GROUPBY_FIELD-->
										<xsl:variable name="curGroup" select="@TS_AudEntLst.ObjDefNm"/>
										<fo:table-cell padding="2pt">
											<fo:block text-align="start">

												<xsl:value-of select="$curGroup" />	
											</fo:block>
										</fo:table-cell>


										<fo:table-cell padding="2pt">
											<fo:block text-align="start">					<!-- GROUPBY_FIELD-->
												<xsl:value-of select="count(//Data/List/Item[@TS_AudEntLst.ObjDefNm = $curGroup])" />
											</fo:block>
										</fo:table-cell>
									
									</xsl:element>
							</xsl:for-each>

						</fo:table-body>
						
					</fo:table>
					<fo:block id="terminator"/>
				</fo:flow>
			</fo:page-sequence>
		</fo:root>
	</xsl:template>

	<xsl:template match="//MetaData">
		<xsl:for-each select="List/Item">
			<fo:table-cell border-top="solid black" border-bottom="solid black" padding="3pt">
				<fo:block>
				<xsl:value-of select="@FlPlnCmpntAttrDefCapt"/>
				</fo:block>
			</fo:table-cell>
		</xsl:for-each>	
	
	</xsl:template>

</xsl:stylesheet>